<app-loading *ngIf="isLoadingPage"></app-loading>
<div class="btnAddNew__wrap">
    <mb-button [mbButtonAvailableStyle]="'PRIMARY'" [mbButtonSize]="'MEDIUM'"
               mbButtonText="{{'common.button.createRequest' | translate}}"
               nz-popover
               [(nzPopoverVisible)]="isShowPopOver"
               [nzPopoverTitle]="titleAddNewTemplate"
               [nzPopoverContent]="contentAddNewTemplate"
               nzPopoverPlacement="bottomRight"
               nzPopoverTrigger="click"
               class="addNewBtn"
    ></mb-button>
</div>


<ng-template #titleAddNewTemplate>
    <div class="titleAddNewPopOver">
        <h3 class="titleHeader">{{'selfService.taxRegisters.listAddNewOption.titleHeader' | translate}}</h3>
        <em (click)="onClosePopover()" class="btnClose" nz-icon nzType="close" nzTheme="outline"></em>
    </div>
</ng-template>

<ng-template #contentAddNewTemplate>
    <div class="addNewContent">
        <ul class="listRegister">

            <li
                class="listRegister--item"
                *ngFor="let item of listAddNewOption"
                (click)="onItemClick(item)"
            >
                <em nz-icon nzType="form" nzTheme="outline"></em>
                <h4>{{item | translate}}</h4>
            </li>

        </ul>
    </div>
</ng-template>


<div class='content__item content__item--border bg__content--default' style="margin-bottom: 24px">
    <form nz-form [formGroup]='form'>
        <div nz-row [nzGutter]='[30,30]'>
            <!--    Form tìm kiếm -->

            <!--Loại yêu cầu-->
            <div nz-col [nzXs]='24' [nzLg]='6'>
                <mb-select [mbDataSelects]='requestTypes' formControlName='requestTypeId'
                           [mbKeyLabel]="'label'"
                           [mbKeyValue]="'value'"
                           mbPlaceholder="{{'selfService.label.selectRequest' | translate }}"
                           mbLabelText="{{'selfService.label.requestType' | translate}}"></mb-select>
            </div>


            <!--Trạng thái-->
            <div nz-col [nzXs]='24' [nzLg]='6'>
                <mb-select [mbDataSelects]='statusList' formControlName='status'
                           mbPlaceholder="{{'selfService.label.selectStatus' | translate }}"
                           mbLabelText="{{'selfService.label.status' | translate}}"></mb-select>
            </div>


            <!--Từ ngày-->
            <div nz-col [nzXs]='24' [nzLg]='6'>
                <mb-date-picker
                    [mbType]="(form.controls['fromDate'].errors || form.errors?.rangeDateError) ? 'error' : 'default'"
                    [mbShowError]="(form.controls['fromDate'].errors || form.errors?.rangeDateError) !== null"
                    [mbErrors]="form.errors?.rangeDateError ? form.errors : form.controls['fromDate'].errors"
                    [mbErrorDefs]="[{ errorName: 'rangeDateError', errorDescription: 'selfService.validate.rangeDate.pareDate' | translate:{'fromDate': 'selfService.label.fromDate' | translate, 'toDate': 'selfService.label.toDate' | translate}}]"
                    mbPlaceholderText="{{'selfService.label.fromDate' | translate}}"
                    mbLabelText="{{'selfService.label.fromDate' | translate}}"
                    formControlName='fromDate'></mb-date-picker>
            </div>


            <!--Đến ngày-->
            <div nz-col [nzXs]='24' [nzLg]='6'>
                <mb-date-picker
                    [mbType]="form.controls['toDate'].errors ? 'error' : 'default'"
                    [mbShowError]="form.controls['toDate'].errors !== null"
                    [mbErrors]="form.controls['toDate'].errors"
                    mbPlaceholderText="{{'selfService.label.toDate' | translate}}"
                    mbLabelText="{{'selfService.label.toDate' | translate}}"
                    formControlName='toDate'></mb-date-picker>
            </div>

            <!--    End Form tìm kiếm-->
        </div>


        <!--Button tìm kiếm-->
        <div nz-row [nzGutter]='[30,30]' class="btnSearch--wrap">
            <div nz-col [nzXs]='24' [nzLg]='24' [align]="'center'">
                <mb-button mbButtonSize='MEDIUM' mbButtonAvailableStyle='SEARCH' (click)='doSearch()'
                           mbButtonText="{{'selfService.label.search' | translate}}"
                ></mb-button>
            </div>
        </div>

    </form>
</div>

<div class='content__item content__item--border bg__content--default content__basic-search' style="padding: 0">
    <mb-table-wrap>
        <mb-table (changePageNum)='search($event)'
                  [tableConfig]='tableConfig' [tableData]='searchResult'
                  (onDblClickNode)="onDblClickNode($event)"
        ></mb-table>
    </mb-table-wrap>
</div>

<ng-template #actionTmpl let-status='status' let-regTypeCode='regTypeCode' let-regType='regType'
             let-registerId='registerId'>
    <em nz-icon
       class="menu__item--btn"
       nz-button
       nzType="more"
       nzTheme="outline"
       nzTrigger="click"
       nz-dropdown
       [nzDropdownMenu]="menu"
       [nzClickHide]="false"
    ></em>
    <nz-dropdown-menu #menu="nzDropdownMenu" style="margin-left: -90px !important;">
        <ul nz-menu style="width: 150px !important; padding: 0">
            <li
                nz-button
                nz-menu-item
                style="padding: 0 20px"
                [ngClass]="{'': regType | isDisplayAction:SEND_BROWSE_ACTION, 'hiddenClass': !(regType | isDisplayAction:SEND_BROWSE_ACTION)}"
                [nzDisabled]="regType | isDisableAction:SEND_BROWSE_ACTION:status"
                (click)="onSendBrowseClick(registerId, regTypeCode)"
            >
                <div class="menu__item">
                    <em nz-icon nzType="check" nzTheme="outline" style="margin-right: 10px"></em>
                    <span>{{'common.button.sendBrowse' | translate}}</span>
                </div>
            </li>
            <li
                nz-button
                nz-menu-item
                style="padding: 0 20px"
                [ngClass]="{'': regType | isDisplayAction:CANCEL_ACTION, 'hiddenClass': !(regType | isDisplayAction:CANCEL_ACTION)}"
                [nzDisabled]="regType | isDisableAction:CANCEL_ACTION:status"
                (click)="onCancelRequestClick(registerId, regTypeCode)"
            >
                <div class="menu__item">
                    <em nz-icon nzType="close" nzTheme="outline" style="margin-right: 10px"></em>
                    <span>{{'common.button.cancelRequest' | translate}}</span>
                </div>
            </li>
            <li
                nz-menu-item
                nz-button
                style="padding: 0 20px"
                [ngClass]="{'': regType | isDisplayAction:EDIT_ACTION, 'hiddenClass': !(regType | isDisplayAction:EDIT_ACTION)}"
                [nzDisabled]="regType | isDisableAction:EDIT_ACTION:status"
                (click)="onEditClick(registerId, regTypeCode)"
            >
                <div class="menu__item">
                    <em nz-icon nzType="edit" nzTheme="outline" style="margin-right: 10px"></em>
                    <span>{{'common.button.edit' | translate}}</span>
                </div>
            </li>
            <li
              nz-menu-item
              nz-button
              style="padding: 0 20px"
              (click)="onEditClick(registerId, regTypeCode, true)"
            >
              <div class="menu__item">
                <em nz-icon nzType="eye" nzTheme="outline" style="margin-right: 10px"></em>
                <span>{{'selfService.label.detail' | translate}}</span>
              </div>
            </li>
            <li
                nz-button
                nz-menu-item
                style="padding: 0 20px"
                [ngClass]="{'': regType | isDisplayAction:DELETE_ACTION, 'hiddenClass': !(regType | isDisplayAction:DELETE_ACTION)}"
                [nzDisabled]="regType | isDisableAction:DELETE_ACTION:status"
                (click)="onDeleteClick(registerId, regTypeCode)"
            >
                <div class="menu__item">
                    <em nz-icon nzType="delete" nzTheme="outline" style="margin-right: 10px"></em>
                    <span>{{'common.button.delete' | translate}}</span>
                </div>
            </li>
            <li
                nz-button
                nz-menu-item
                style="padding: 0 20px"
                (click)="onViewHistoryClick(registerId, regTypeCode)"
            >
                <div class="menu__item">
                    <em nz-icon nzType="history" nzTheme="outline" style="margin-right: 10px"></em>
                    <span>{{'common.button.viewHistory' | translate}}</span>
                </div>
            </li>
        </ul>
    </nz-dropdown-menu>
</ng-template>

<ng-template #statusTmpl let-status='status'>
    <ng-container *ngFor='let item of constant.STATUSES'>
        <nz-tag [nzColor]="item.bgColor" [ngStyle]="{'color': item.color}" *ngIf='status?.toString() === item.value'>{{item.label | translate}}</nz-tag>
    </ng-container>
</ng-template>

<ng-template #footerTmpl>
    <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="cancel()" mbButtonBgColor="transparent"
               mbButtonText="{{'common.button.close' | translate}}"></mb-button>
</ng-template>

<ng-template #registerInfoTmpl let-registerInformation="registerInformation" let-regTypeCode="regTypeCode" let-toDate="toDate">
    <!-- Nếu loại đk là giảm người phụ thuộc -->
    <ng-container *ngIf="regTypeCode === constant.REG_TYPE.REGISTER_LOW_DP;else otherContent">
        <div>+ {{registerInformation}}</div>
        <div *ngIf="toDate">+ {{'selfService.dependentRegisters.toDate1' | translate}}: {{toDate}}</div>
    </ng-container>

    <ng-template #otherContent>
        <span>{{registerInformation}}</span>
    </ng-template>
</ng-template>
